diff -urN versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/fiscal.py trunk/stoqdrivers/printers/fiscal.py
--- versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/fiscal.py	2016-12-29 14:30:59.000000000 -0200
+++ trunk/stoqdrivers/printers/fiscal.py	2017-01-23 16:54:44.689415054 -0200
@@ -1,37 +1,35 @@
 # -*- Mode: Python; coding: utf-8 -*-
 # vi:si:et:sw=4:sts=4:ts=4
 
-##
-## Stoqdrivers
-## Copyright (C) 2005-2007 Async Open Source <http://www.async.com.br>
-## All rights reserved
-##
-## This program is free software; you can redistribute it and/or modify
-## it under the terms of the GNU General Public License as published by
-## the Free Software Foundation; either version 2 of the License, or
-## (at your option) any later version.
-##
-## This program is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
-## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-## GNU General Public License for more details.
-##
-## You should have received a copy of the GNU General Public License
-## along with this program; if not, write to the Free Software
-## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
-## USA.
-##
-## Author(s):   Johan Dahlin     <jdahlin@async.com.br>
-##              Henrique Romano  <henrique@async.com.br>
-##
+#
+# Stoqdrivers
+# Copyright (C) 2005-2007 Async Open Source <http://www.async.com.br>
+# All rights reserved
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
+# USA.
+#
+# Author(s):   Johan Dahlin     <jdahlin@async.com.br>
+#              Henrique Romano  <henrique@async.com.br>
+#
 
 import datetime
 from decimal import Decimal
-
 from kiwi.datatypes import currency
-from kiwi.argcheck import number, percent
-from kiwi.log import Logger
-
+from kiwi.argcheck import number
+from stoqdrivers.logs.log import traced as log
 from stoqdrivers.exceptions import (CloseCouponError, PaymentAdditionError,
                                     AlreadyTotalized, InvalidValue)
 from stoqdrivers.enum import PaymentMethodType, TaxType, UnitType
@@ -42,11 +40,11 @@
 
 _ = stoqdrivers_gettext
 
-log = Logger('stoqdrivers.fiscalprinter')
-
 #
 # Extra data types to argcheck
 #
+TWOPLACES = Decimal(10) ** -2
+
 
 class taxcode(number):
     @classmethod
@@ -55,6 +53,7 @@
                          TaxType.EXEMPTION):
             raise ValueError("%s must be one of TaxType.* constants" % name)
 
+
 class unit(number):
     @classmethod
     def value_check(cls, name, value):
@@ -62,6 +61,7 @@
                          UnitType.EMPTY, UnitType.CUSTOM):
             raise ValueError("%s must be one of UNIT_* constants" % name)
 
+
 class payment_method(number):
     @classmethod
     def value_check(cls, name, value):
@@ -69,6 +69,7 @@
                          PaymentMethodType.CUSTOM):
             raise ValueError("%s must be one of *_PM constants" % name)
 
+
 #
 # FiscalPrinter interface
 #
@@ -76,6 +77,7 @@
 class FiscalPrinter(BasePrinter):
     def __init__(self, brand=None, model=None, device=None, config_file=None,
                  *args, **kwargs):
+
         BasePrinter.__init__(self, brand, model, device, config_file, *args,
                              **kwargs)
         self._has_been_totalized = False
@@ -83,6 +85,11 @@
         self.totalized_value = Decimal("0.0")
         self._capabilities = self._driver.get_capabilities()
         self._charset = self._driver.coupon_printer_charset
+        self._serial = None
+
+    def refresh(self):
+        print dir(self)
+        # self.refresh()
 
     def get_capabilities(self):
         return self._capabilities
@@ -92,222 +99,426 @@
 
     @capcheck(basestring, basestring, basestring)
     def identify_customer(self, customer_name, customer_address, customer_id):
-        log.info('identify_customer(customer_name=%r, '
-                  'customer_address=%r, customer_id=%r)' % (
-            customer_name, customer_address, customer_id))
-
-        self._driver.coupon_identify_customer(
-            self._format_text(customer_name),
-            self._format_text(customer_address),
-            self._format_text(customer_id))
+        log.info('> CMD: identify_customer(customer_name=%r, customer_address=%r, customer_id=%r)'
+                 % (customer_name, customer_address, customer_id))
+
+        res = self._driver.coupon_identify_customer(self._format_text(customer_name),
+                                                    self._format_text(customer_address),
+                                                    self._format_text(customer_id))
+        log.info('< RET: %s' % str(res))
+        return res
 
     def coupon_is_customer_identified(self):
-        return self._driver.coupon_is_customer_identified()
+        log.info('> CMD: coupon_is_customer_identified()')
+        res = self._driver.coupon_is_customer_identified()
+        log.info('< RET: %s' % str(res))
+        return res
 
     def open(self):
-        log.info('coupon_open()')
-
-        return self._driver.coupon_open()
+        log.info('> CMD: coupon_open()')
+        res = self._driver.coupon_open()
+        log.info('< RET: ' + str(res))
+        return res
 
-    @capcheck(basestring, basestring, Decimal, str, Decimal, unit,
-              Decimal, Decimal, basestring)
+    @capcheck(basestring, basestring, Decimal, str, Decimal, unit, Decimal, Decimal, basestring)
     def add_item(self, item_code, item_description, item_price, taxcode,
-                 items_quantity=Decimal("1.0"), unit=UnitType.EMPTY,
-                 discount=Decimal("0.0"), surcharge=Decimal("0.0"),
-                 unit_desc=""):
-        log.info("add_item(code=%r, description=%r, price=%r, "
-                 "taxcode=%r, quantity=%r, unit=%r, discount=%r, "
-                 "surcharge=%r, unit_desc=%r)" % (
-            item_code, item_description, item_price, taxcode,
-            items_quantity, unit, discount, surcharge, unit_desc))
+                 items_quantity=Decimal("1.0"), unit=UnitType.EMPTY, discount=Decimal("0.0"),
+                 surcharge=Decimal("0.0"), unit_desc=""):
+
+        log.info("> CMD: add_item(code=%r, description=%r, price=%r, taxcode=%r, quantity=%r, "
+                 "unit=%r, discount=%r, surcharge=%r, unit_desc=%r)" %
+                 (item_code, item_description, item_price, taxcode, items_quantity, unit, discount,
+                  surcharge, unit_desc))
 
         if self._has_been_totalized:
-            raise AlreadyTotalized("the coupon is already totalized, you "
-                                   "can't add more items")
+            err = "O Cupom já foi totalizado, você não pode mais adicionar itens"
+            log.error('< ERR: ' + err)
+            raise AlreadyTotalized(err)
+
         if discount and surcharge:
-            raise TypeError("discount and surcharge can not be used together")
+            err = "discount and surcharge can not be used together"
+            log.error('< ERR: ' + err)
+            raise TypeError(err)
+
         elif unit != UnitType.CUSTOM and unit_desc:
-            raise ValueError("You can't specify the unit description if "
-                             "you aren't using UnitType.CUSTOM constant.")
+            err = "You can't specify the unit description if you aren't using UnitType.CUSTOM constant."
+            log.error('< ERR: ' + err)
+            raise ValueError(err)
+
         elif unit == UnitType.CUSTOM and not unit_desc:
-            raise ValueError("You must specify the unit description when "
-                             "using UnitType.CUSTOM constant.")
+            err = "You must specify the unit description when using UnitType.CUSTOM constant."
+            log.error('< ERR: ' + err)
+            raise ValueError(err)
+
         elif unit == UnitType.CUSTOM and len(unit_desc) != 2:
-            raise ValueError("unit description must be 2-byte sized string")
+            err = "unit description must be 2-byte sized string"
+            log.error('< ERR: ' + err)
+            raise ValueError(err)
+
         if not item_price:
-            raise InvalidValue("The item value must be greater than zero")
+            err = "The item value must be greater than zero"
+            log.error('< ERR: ' + err)
+            raise InvalidValue(err)
+
+        retval = self._driver.coupon_add_item(self._format_text(item_code),
+                                              self._format_text(item_description),
+                                              item_price, taxcode, items_quantity,
+                                              unit, discount, surcharge,
+                                              unit_desc=self._format_text(unit_desc))
+        log.info('< RET: ' + str(retval))
+        return retval
 
-        return self._driver.coupon_add_item(
-            self._format_text(item_code), self._format_text(item_description),
-            item_price, taxcode, items_quantity, unit, discount, surcharge,
-            unit_desc=self._format_text(unit_desc))
+    def desc_acres_item(self, desc_acres, item, valor):
+        log.info('> CMD: desc_acres_item(desc_acres=%s, item=%s, valor=%s)' % (desc_acres, item, valor))
+        res = self._driver.desc_acres_item(desc_acres, item, valor)
+        log.info('< RET: %s' % str(res))
+        return res
 
     @capcheck(Decimal, Decimal, taxcode)
     def totalize(self, discount=currency(0), surcharge=currency(0),
                  taxcode=TaxType.NONE):
-        log.info('totalize(discount=%r, surcharge=%r, taxcode=%r)' % (
+        log.info('> CMD: totalize(discount=%r, surcharge=%r, taxcode=%r)' % (
             discount, surcharge, taxcode))
 
         if discount and surcharge:
-            raise TypeError("discount and surcharge can not be used together")
+            err = "discount and surcharge can not be used together"
+            log.error('< ERR: ' + err)
+            raise TypeError(err)
+
+        if discount > self.get_coupon_subtotal():
+            err = "Valor do Desconto/Acrescimo nao pode ser maior que o Total do Cupom"
+            log.error('< ERR: ' + err)
+            raise ValueError(err)
+
         if surcharge and taxcode == TaxType.NONE:
-            raise ValueError("to specify a surcharge you need specify its "
-                             "tax code")
-        result = self._driver.coupon_totalize(discount, surcharge, taxcode)
+            err = "to specify a surcharge you need specify its tax code"
+            log.error('< ERR: ' + err)
+            raise ValueError(err)
+
+        res = self._driver.coupon_totalize(discount, surcharge, taxcode)
         self._has_been_totalized = True
-        self.totalized_value = result
-        return result
+        self.totalized_value = res
+
+        log.info("< RET: %s\n%s" % (str(res), "FIM DO TOTALIZE ================================================================"))
+
+        return res
+
+    def configure_payment_methods(self, descricao=u''):
+        log.info('> CMD: configure_payment_methods(descricao=%r)' % descricao)
+        res = self._driver._configure_payment_methods(descricao)
+        log.info('< RET: %s' % str(res))
+        return res
 
     @capcheck(basestring, Decimal, basestring)
     def add_payment(self, payment_method, payment_value, description=''):
-        log.info("add_payment(method=%r, value=%r, description=%r)" % (
-            payment_method, payment_value, description))
+        log.info("> CMD: add_payment(method=%r, value=%r, description=%r)" % (payment_method,
+                                                                              payment_value,
+                                                                              description))
 
         if not self._has_been_totalized:
-            raise PaymentAdditionError(_("You must totalize the coupon "
-                                         "before add payments."))
-        result = self._driver.coupon_add_payment(
-            payment_method, payment_value,
-            self._format_text(description))
+            err = "Você deve totalizar o cupom antes de fecha-lo."
+            log.error('< ERR: %s' % err)
+            raise PaymentAdditionError(_(err))
+
+        res = self._driver.coupon_add_payment(payment_method, payment_value,
+                                              self._format_text(description))
+
+        log.info('< RET: %s' % str(res))
+
         self.payments_total_value += payment_value
-        return result
+        return res
+
+    def open_cash_drawer(self, sec=0):
+        log.info('> CMD: open_cash_drawer(sec=%r)' % sec)
+        res = self._driver.open_cash_drawer(sec)
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def get_status_cash_drawer(self):
+        log.info('> CMD: get_status_cash_drawer()')
+        res = self._driver.get_status_cash_drawer()
+        log.info('< RET: %s' % str(res))
+        return res
 
     def cancel(self):
-        log.info('coupon_cancel()')
-        retval = self._driver.coupon_cancel()
+        log.info('> CMD: coupon_cancel()')
+        res = self._driver.coupon_cancel()
+        log.info('< RET: %s' % str(res))
         self._has_been_totalized = False
         self.payments_total_value = Decimal("0.0")
         self.totalized_value = Decimal("0.0")
-        return retval
+        return res
 
     def cancel_last_coupon(self):
         """Cancel the last non fiscal coupon or the last sale."""
-        self._driver.cancel_last_coupon()
+        log.info('> CMD: cancel_last_coupon()')
+        res = self._driver.cancel_last_coupon()
+        log.info('< RET: %s' % str(res))
+        return res
 
-    @capcheck(int)
-    def cancel_item(self, item_id):
-        log.info('coupon_cancel_item(item_id=%r)' % (item_id,))
+    def _get_last_item_id(self):
+        log.info('> CMD: _get_last_item_id()')
+        res = self._driver._get_last_item_id()
+        log.info('< RET: %s' % str(res))
+        return res
 
-        return self._driver.coupon_cancel_item(item_id)
+
+    @capcheck(int)
+    def cancel_item(self, item_id=None):
+        log.info('> CMD: coupon_cancel_item(item_id=%r)' % (item_id,))
+        res = self._driver.coupon_cancel_item(item_id)
+        log.info('< RET: %s' % str(res))
+        return res
 
     @capcheck(basestring)
     def close(self, promotional_message=''):
-        log.info('coupon_close(promotional_message=%r)' % (
-            promotional_message))
+        log.info('> CMD: coupon_close(promotional_message=%r)' % promotional_message)
 
         if not self._has_been_totalized:
-            raise CloseCouponError(_("You must totalize the coupon before "
-                                     "closing it"))
+            err = "Você deve totalizar o cupom antes de fecha-lo."
+            log.error('< ERR: %s' % err)
+            raise CloseCouponError(_(err))
+
         if not self.payments_total_value:
-            raise CloseCouponError(_("It is not possible close the coupon "
-                                     "since there are no payments defined."))
+            err = "Não é possível fechar o cupom, pois não existem pagamentos definidos."
+            log.error('< ERR: %s' % err)
+            raise CloseCouponError(_(err))
+
         if self.totalized_value > self.payments_total_value:
-            raise CloseCouponError(_("Isn't possible close the coupon since "
-                                     "the payments total (%.2f) doesn't "
-                                     "match the totalized value (%.2f).")
-                                   % (self.payments_total_value,
-                                      self.totalized_value))
-        res = self._driver.coupon_close(
-            self._format_text(promotional_message))
+            err = "Não é possível fechar o cupom porque os pagamentos totais (%.2f) " \
+                  "não coicide com o valor totalizado (%.2f)."
+            log.error('< ERR: %s' % err)
+            raise CloseCouponError(_(err) % (self.payments_total_value, self.totalized_value))
+
+        res = self._driver.coupon_close(self._format_text(promotional_message))
+        log.info('< RET: %s' % str(res))
+
+        self.get_status().check_error_two()  # Verifica se teve algum erro na transacao com ECF
         self._has_been_totalized = False
         self.payments_total_value = Decimal("0.0")
         self.totalized_value = Decimal("0.0")
+
         return res
 
     def summarize(self):
-        log.info('summarize()')
+        log.info('> CMD: summarize()')
+        res = self._driver.summarize()
+        log.info('< RET: %s' % str(res))
+        return res
 
-        return self._driver.summarize()
+    def get_totalizadores(self, total=False):
+        log.info('> CMD: get_totalizadores(total=%s)' % total)
+        res = self._driver.get_totalizadores(total=total)
+        log.info('< RET: %s' % str(res))
+        return res
 
     def close_till(self, previous_day=False):
-        log.info('close_till(previous_day=%r)' % (previous_day,))
-
-        return self._driver.close_till(previous_day)
+        log.info('> CMD: close_till(previous_day=%r)' % (previous_day,))
+        res = self._driver.close_till(previous_day)
+        log.info('< RET: %s' % str(res))
+        return res
 
-    @capcheck(Decimal)
-    def till_add_cash(self, add_cash_value):
-        log.info('till_add_cash(add_cash_value=%r)' % (add_cash_value,))
+    def _add_voucher(self, type, add_voucher_value, text=''):
+        log.info('> CMD: _add_voucher(type=%r, add_voucher_value=%r, text=%r)'
+                 % (type, add_voucher_value, text))
+        res = self._driver._add_voucher(type, add_voucher_value, text)
+        log.info('< RET: %s' % str(res))
+        return res
 
-        return self._driver.till_add_cash(add_cash_value)
+    @capcheck(Decimal, int, int)
+    def till_add_cash(self, add_cash_value, totalizador=0, meio=0):
+        log.info('> CMD: till_add_cash(add_cash_value=%r, totalizador=%r, meio=%r)'
+                 % (add_cash_value, totalizador, meio))
+        res = self._driver.till_add_cash(add_cash_value, totalizador=totalizador, meio=meio)
+        log.info('< RET: %s' % str(res))
+        return res
 
-    @capcheck(Decimal)
-    def till_remove_cash(self, remove_cash_value):
-        log.info('till_remove_cash(remove_cash_value=%r)' % (
-            remove_cash_value,))
+    @capcheck(Decimal, int, str)
+    def till_remove_cash(self, remove_cash_value, cod=0, text=''):
+        log.info('> CMD: till_remove_cash(remove_cash_value=%r, cod=%r, text=%r)'
+                 % (remove_cash_value, cod, text))
 
-        return self._driver.till_remove_cash(remove_cash_value)
+        res = self._driver.till_remove_cash(remove_cash_value, cod=cod, text=text)
+        log.info('< RET: %s' % str(res))
+        return res
 
-    @capcheck(datetime.date, datetime.date)
-    def till_read_memory(self, start, end):
+    @capcheck(datetime.date, datetime.date, bool)
+    def till_read_memory(self, start, end, full=False):
         assert start <= end <= datetime.date.today(), (
             "start must be less then end and both must be less today")
-        log.info('till_read_memory(start=%r, end=%r)' % (
-            start, end))
 
-        return self._driver.till_read_memory(start, end)
+        log.info('> CMD: till_read_memory(start=%r, end=%r)' % (start, end))
+
+        res = self._driver.till_read_memory(start, end, full)
+        log.info('< RET: %s' % str(res))
+        return res
 
-    @capcheck(datetime.date, datetime.date)
-    def till_read_memory_to_serial(self, start, end):
+    @capcheck(datetime.date, datetime.date, bool)
+    def till_read_memory_to_serial(self, start, end, full=False):
         assert start <= end <= datetime.date.today(), (
             "start must be less then end and both must be less today")
-        log.info('till_read_memory(start=%r, end=%r)' % (
-            start, end))
 
-        return self._driver.till_read_memory_to_serial(start, end)
+        log.info('> CMD: till_read_memory(start=%r, end=%r)' % (start, end))
+
+        res = self._driver.till_read_memory_to_serial(start, end, full)
+        log.info('< RET: %s' % res)
+        return res
+
+    @capcheck(int, int, bool)
+    def till_read_memory_by_reductions(self, start, end, full=False):
+        assert end >= start > 0, ("start must be less then end and both must be positive")
+        log.info('> CMD: till_read_memory_by_reductions(start=%r, end=%r)' % (start, end))
+
+        res = self._driver.till_read_memory_by_reductions(start, end, full)
+        log.info('< RET: %s' % str(res))
+        return res
+
+    @capcheck(int, int, bool)
+    def till_read_memory_by_reductions_to_serial(self, start, end, full=False):
+        assert end >= start > 0, ("start must be less then end and both must be positive")
+        log.info('> CMD: till_read_memory_by_reductions(start=%r, end=%r)' % (start, end))
+        res = self._driver.till_read_memory_by_reductions_to_serial(start, end, full)
+        log.info('< RET: %s' % res)
+        return res
 
-    @capcheck(int, int)
-    def till_read_memory_by_reductions(self, start, end):
-        assert end >= start > 0, ("start must be less then end "
-                                  "and both must be positive")
-        log.info('till_read_memory_by_reductions(start=%r, end=%r)' % (
-            start, end))
+    def gerencial_report_open(self, id=0):
+        log.info('> CMD: gerencial_report_open(id=%r)' % id)
+        res = self._driver.gerencial_report_open(id=id)
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def gerencial_report_print(self, text):
+        log.info('> CMD: gerencial_report_print(text=%s)' % text)
+        res = self._driver.gerencial_report_print(text)
+        log.info('< RET: %s' % str(res))
+        return res
 
-        self._driver.till_read_memory_by_reductions(start, end)
+    def gerencial_report_close(self):
+        log.info('> CMD: gerencial_report_open()')
+        res = self._driver.gerencial_report_close()
+        log.info('< RET: %s' % str(res))
+        return res
 
     def payment_receipt_open(self, identifier, coo, method, value):
-        log.info('payment_receipt_open(identifier=%s, coo=%s, method=%s, value=%s)'
-                  % (identifier, coo, method, value))
-        return self._driver.payment_receipt_open(identifier, coo, method, value)
+        log.info('> CMD: payment_receipt_open(identifier=%s, coo=%s, method=%s, value=%s)'
+                 % (identifier, coo, method, value))
+        res = self._driver.payment_receipt_open(identifier=identifier, coo=coo, method=method,
+                                                value=value)
+        log.info('< RET: %s' % str(res))
+        return res
 
     def payment_receipt_print(self, text):
-        log.info('payment_receipt_print(text=%s)' % text)
-        return self._driver.payment_receipt_print(text)
+        log.info('> CMD: payment_receipt_print(text=%s)' % text)
+        res = self._driver.payment_receipt_print(text)
+        log.info('< RET: %s' % str(res))
+        return res
 
     def payment_receipt_close(self):
-        log.info('payment_receipt_close()')
-        return self._driver.payment_receipt_close()
+        log.info('> CMD: payment_receipt_close()')
+        res = self._driver.payment_receipt_close()
+        log.info('< RET: %s' % str(res))
+        return res
 
     def payment_receipt_print_duplicate(self):
-        log.info('payment_receipt_print_duplicate()')
-        return self._driver.payment_receipt_print_duplicate()
+        log.info('> CMD: payment_receipt_print_duplicate()')
+        res = self._driver.payment_receipt_print_duplicate()
+        log.info('< RET: %s' % str(res))
+        return res
 
     def get_serial(self):
-        log.info('get_serial()')
+        log.info('> CMD: get_serial()')
+        self._serial = self._driver.get_serial() if not self._serial else self._serial
+        res = self._serial
+        log.info('< RET: %s' % res)
+        return res
 
-        return self._driver.get_serial()
+    def get_serial_mfd(self):
+        log.info('> CMD: get_serial()')
+        res = self._driver.get_serial_mfd()
+        log.info('< RET: %s' % str(res))
+        return res
 
     def query_status(self):
-        log.info('query_status()')
+        log.info('> CMD: query_status()')
+        res = self._driver.query_status()
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def send_command(self, command, *args, **kwargs):
+        res = self._driver._send_command(command, *args, **kwargs)
+        return res
+
+    def get_status(self, val=None, cmd_status=None):
+        log.info('> CMD: get_status(val=%r, cmd_status=%r)' % (val, cmd_status))
+        res = self._driver.get_status(val, cmd_status)
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def get_ecf_date(self):
+        log.info('> CMD: get_ecf_date()')
+        res = self._driver.get_ecf_date()
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def get_coupon_subtotal(self):
+        log.info('> CMD: get_coupon_subtotal()')
+        res = self._driver._get_coupon_subtotal()
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def emite_leitura_fita_detalhe(self, *args, **kwargs):
+        log.info('> CMD: emite_leitura_fita_detalhe(%s,%s)' % (args, kwargs))
+        res = self._driver._emite_leitura_fita_detalhe(args, kwargs)
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def le_impressao(self):
+        log.info('> CMD: le_impressao()')
+        res = self._driver._le_impressao()
+        log.info('< RET: %s' % str(res))
+        return res
 
-        return self._driver.query_status()
+    def set_summertime(self, value=True):
+        log.info('> CMD: set_summertime(value=%r)' % value)
+        res = self._driver.set_summertime(value)
+        log.info('< RET: %s' % str(res))
+        return res
+
+    def get_summertime(self):
+        log.info('> CMD: get_summertime()')
+        res = self._driver.get_summertime()
+        log.info('< RET: %s' % str(res))
+        return res
 
     def status_reply_complete(self, reply):
-        log.info('status_reply_complete(%s)' % (reply,))
-        return self._driver.status_reply_complete(reply)
+        log.info('> CMD: status_reply_complete(%s)' % (reply,))
+        res = self._driver.status_reply_complete(reply)
+        log.info('< RET: %s' % str(res))
+        return res
 
     def get_tax_constants(self):
-        log.info('get_tax_constants()')
+        log.info('> CMD: get_tax_constants()')
+        res = self._driver.get_tax_constants()
+        log.info('< RET: %s' % str(res))
+        return res
 
-        return self._driver.get_tax_constants()
+    def get_tax(self):
+        log.info('> CMD: get_tax()')
+        res = self._driver.get_tax()
+        log.info('< RET: %s' % res)
+        return res
 
     def get_payment_constants(self):
-        log.info('get_payment_constants()')
-
-        return self._driver.get_payment_constants()
+        log.info('> CMD: get_payment_constants()')
+        res = self._driver.get_payment_constants()
+        log.info('< RET: %s' % res)
+        return res
 
     def get_payment_receipt_identifier(self, method):
-        log.info('get_payment_receipt_identifier(method=%s)' % method)
-        return self._driver.get_payment_receipt_identifier(method)
+        log.info('> CMD: get_payment_receipt_identifier(method=%s)' % method)
+        res = self._driver.get_payment_receipt_identifier(method)
+        log.info('< RET: %s' % res)
+        return res
 
     def get_ccf(self):
         """Fiscal Coupon Counter
@@ -315,9 +526,10 @@
         @returns: the last document ccf
         @rtype: integer
         """
-        log.info('get_ccf()')
-
-        return self._driver.get_ccf()
+        log.info('> CMD: get_ccf()')
+        res = self._driver.get_ccf()
+        log.info('< RET: %s' % res)
+        return res
 
     def get_coo(self):
         """Operation Order Counter
@@ -325,9 +537,30 @@
         @returns: the last document coo
         @rtype: integer
         """
-        log.info('get_coo()')
+        log.info('> CMD: get_coo()')
+        res = self._driver.get_coo()
+        log.info('< RET: %s' % res)
+        return res
+
+    def get_coo_inicial_final(self):
+        """Operation Order Counter
+            @returns: the last document coo
+            @rtype: integer
+            """
+        log.info('> CMD: get_coo_inicial_final()')
+        res = self._driver.get_coo_inicial_final()
+        log.info('< RET: %s' % res)
+        return res
 
-        return self._driver.get_coo()
+    def get_read_ie(self):
+        """
+        @returns: Iscrição estadual
+        @return:
+        """
+        log.info('> CMD: get_read_ie()')
+        res = self._driver.get_read_ie()
+        log.info('< RET: %s' % res)
+        return res
 
     def get_gnf(self):
         """Nonfiscal Operation General Counter
@@ -335,9 +568,10 @@
         @returns: gnf
         @rtype: integer
         """
-        log.info('get_gnf()')
-
-        return self._driver.get_gnf()
+        log.info('> CMD: get_gnf()')
+        res = self._driver.get_gnf()
+        log.info('< RET: %s' % res)
+        return res
 
     def get_crz(self):
         """Z Reduction Counter
